%define samba_version 3.0.8-0.pre1.3
%define gconf2_version 2.14
%define gtkdoc_version 0.9
# %define gnome_mime_data_version 2.0.0-11
%define perl_XML_Parser_version 2.31-16
%define po_package gnome-vfs-2.0
# %define gnome_mount_version 0.4
%define glib2_version 2.9.3
%define dbus_version 0.90
%define dbus_glib_version 0.70
%define hal_version 0.5.7
%define avahi_version 0.6

Summary: The GNOME virtual file-system libraries
Name: gnome-vfs2
Version: 2.24.2
Release: 6%{?dist}
License: LGPLv2+ and GPLv2+
# the daemon and the library are LGPLv2+
# the modules are LGPLv2+ and GPLv2+ 
Group: System Environment/Libraries
Source0: http://download.gnome.org/sources/gnome-vfs/2.24/gnome-vfs-%{version}.tar.bz2
URL: http://www.gnome.org/
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n) 
# Requires:      gnome-mime-data >= %{gnome_mime_data_version}
Requires:      shared-mime-info
# Requires:      gnome-mount >= %{gnome_mount_version}
Requires:      GConf2 >= %{gconf2_version}
Requires(post): GConf2 >= %{gconf2_version}
Requires(pre): GConf2 >= %{gconf2_version}
Requires(preun): GConf2 >= %{gconf2_version}
BuildRequires: GConf2-devel >= %{gconf2_version}
# BuildRequires: gnome-mime-data >= %{gnome_mime_data_version}
BuildRequires: libxml2-devel, zlib-devel
BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: popt, bzip2-devel, ORBit2-devel, openjade
BuildRequires: pkgconfig
BuildRequires: automake
BuildRequires: libtool
BuildRequires: intltool
BuildRequires: autoconf
BuildRequires: gtk-doc >= %{gtkdoc_version}
BuildRequires: perl-XML-Parser >= %{perl_XML_Parser_version}
BuildRequires: libsmbclient-devel >= %{samba_version}
BuildRequires: openssl-devel gamin-devel
BuildRequires: krb5-devel
BuildRequires: avahi-glib-devel >= %{avahi_version}
BuildRequires: hal-devel >= %{hal_version}
BuildRequires: dbus-devel >= %{dbus_version}
BuildRequires: dbus-glib-devel >= %{dbus_glib_version}
# BuildRequires: gnome-mount-devel >= %{gnome_mount_version} 
BuildRequires: gettext
BuildRequires: libacl-devel
BuildRequires: libselinux-devel
BuildRequires: keyutils-libs-devel


# Translation updates
# https://bugzilla.redhat.com/show_bug.cgi?id=589209
Patch1: translation-updates.patch

Patch3: gnome-vfs-2.9.90-modules-conf.patch

# remove gnome-mime-data dependency
Patch4: gnome-vfs-2.24.1-disable-gnome-mime-data.patch

# CVE-2009-2473 neon, gnome-vfs2 embedded neon: billion laughs DoS attack
# https://bugzilla.redhat.com/show_bug.cgi?id=518215
Patch5: gnome-vfs-2.24.3-CVE-2009-2473.patch

# send to upstream
Patch101:	gnome-vfs-2.8.2-schema_about_for_upstream.patch

# Default
Patch104:	gnome-vfs-2.8.2-browser_default.patch

# Applied upstream.
# Patch201: gnome-vfs-2.8.1-console-mount-opt.patch

# RH bug #197868
Patch6: gnome-vfs-2.15.91-mailto-command.patch

# https://bugzilla.gnome.org/show_bug.cgi?id=613643
Patch7: gnome-vfs2-dir-prefix.patch


# https://bugzilla.redhat.com/show_bug.cgi?id=333041
# https://bugzilla.redhat.com/show_bug.cgi?id=335241
Patch300: gnome-vfs-2.20.0-ignore-certain-mountpoints.patch


# backported from upstream

# gnome-vfs-daemon exits on dbus, and constantly restarted causing dbus/hal to hog CPU
# https://bugzilla.redhat.com/show_bug.cgi?id=486286
Patch404: gnome-vfs-2.24.xx-utf8-mounts.patch

# https://bugzilla.gnome.org/show_bug.cgi?id=435653
Patch405: 0001-Add-default-media-application-schema.patch


%description
GNOME VFS is the GNOME virtual file system. It is the foundation of
the Nautilus file manager. It provides a modular architecture and
ships with several modules that implement support for file systems,
http, ftp, and others. It provides a URI-based API, backend
supporting asynchronous file operations, a MIME type manipulation
library, and other features.

%package devel
Summary: Libraries and include files for developing GNOME VFS applications
Group: Development/Libraries
Requires:   %{name} = %{version}-%{release}
Requires:   GConf2-devel >= %{gconf2_version}
Requires:   hal-devel >= %{hal_version}
Requires:   dbus-devel >= %{dbus_version}
Requires:   dbus-glib-devel >= %{dbus_glib_version}
Requires:   pkgconfig
Conflicts: gnome-vfs-devel < 1.0.2

%description devel
This package provides the necessary development libraries for writing
GNOME VFS modules and applications that use the GNOME VFS APIs.

%package smb
Summary: Windows fileshare support for gnome-vfs
Group: System Environment/Libraries
Requires:   %{name} = %{version}-%{release}
Requires: libsmbclient >= %{samba_version}
Obsoletes:     gnome-vfs2-extras
Provides:     gnome-vfs2-extras

%description smb
This package provides support for reading and writing files on windows
shares (SMB) to applications using GNOME VFS.

%prep
%setup -q -n gnome-vfs-%{version} 

%patch1 -p1 -b .translations
%patch3 -p1 -b .modules-conf
%patch4 -p1 -b .mime-data
%patch5 -p1 -b .CVE-2009-2473

%patch6 -p1 -b .mailto-command
%patch7 -p1 -b .add-dir

# send to upstream
%patch101 -p1 -b .schema_about

%patch104 -p1 -b .browser_default

%patch300 -p1 -b .ignore-certain-mount-points

%patch404 -p1 -b .utf8-mounts

%patch405 -p1 -b .default-media

# Convert non UTF-8 files
mkdir -p __temp
for f in AUTHORS ; do
  cp -p $f __temp/$f
  iconv -f ISO-8859-1 -t UTF-8 __temp/$f > $f
  touch -r __temp/$f $f
done
rm -rf __temp

# for patch 10 and 4
autoheader
autoconf

%build

if pkg-config openssl ; then
	CPPFLAGS=`pkg-config --cflags openssl`; export CPPFLAGS
	LDFLAGS=`pkg-config --libs-only-L openssl`; export LDFLAGS
fi

%configure --disable-gtk-doc --enable-hal 

export tagname=CC
make LIBTOOL=/usr/bin/libtool %{?_smp_mflags}

# strip unneeded translations from .mo files
# ideally intltool (ha!) would do that for us
# http://bugzilla.gnome.org/show_bug.cgi?id=474987
cd po
grep -v ".*[.]desktop[.]in[.]in$\|.*[.]server[.]in[.]in$" POTFILES.in > POTFILES.keep
mv POTFILES.keep POTFILES.in
intltool-update --pot
PO_FAKE_DATE="2009-08-03 18:00+0200"   # fake this to be equal in every build
PO_FAKE_DATE_EXPR='\(.*POT-Creation-Date: *\)\(.*\)\(\\n.*\)'
sed --in-place "s/${PO_FAKE_DATE_EXPR}/\1${PO_FAKE_DATE}\3/" %{po_package}.pot
for p in *.po; do
  msgmerge $p %{po_package}.pot > $p.out
  msgfmt -o `basename $p .po`.gmo $p.out
done


%install
rm -fr $RPM_BUILD_ROOT

export GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL=1
export tagname=CC
make install DESTDIR=$RPM_BUILD_ROOT LIBTOOL=/usr/bin/libtool
unset GCONF_DISABLE_MAKEFILE_SCHEMA_INSTALL

rm -f $RPM_BUILD_ROOT%{_libdir}/gnome-vfs-2.0/modules/lib*.a
rm -f $RPM_BUILD_ROOT%{_libdir}/gnome-vfs-2.0/modules/lib*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.la
rm -f $RPM_BUILD_ROOT%{_libdir}/*.a


%find_lang %{po_package}

%clean
rm -fr %{buildroot}

%post
/sbin/ldconfig
export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
gconftool-2 --makefile-install-rule \
    %{_sysconfdir}/gconf/schemas/system_http_proxy.schemas \
    %{_sysconfdir}/gconf/schemas/system_dns_sd.schemas \
    %{_sysconfdir}/gconf/schemas/system_smb.schemas \
    %{_sysconfdir}/gconf/schemas/desktop_gnome_url_handlers.schemas \
    %{_sysconfdir}/gconf/schemas/desktop_default_applications.schemas \
      > /dev/null || :

%pre
if [ "$1" -gt 1 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \
    %{_sysconfdir}/gconf/schemas/system_http_proxy.schemas \
    %{_sysconfdir}/gconf/schemas/system_dns_sd.schemas \
    %{_sysconfdir}/gconf/schemas/system_smb.schemas \
    %{_sysconfdir}/gconf/schemas/desktop_gnome_url_handlers.schemas \
    %{_sysconfdir}/gconf/schemas/desktop_default_applications.schemas \
      > /dev/null || :
fi

%preun
if [ "$1" -eq 0 ]; then
  export GCONF_CONFIG_SOURCE=`gconftool-2 --get-default-source`
  gconftool-2 --makefile-uninstall-rule \
    %{_sysconfdir}/gconf/schemas/system_http_proxy.schemas \
    %{_sysconfdir}/gconf/schemas/system_dns_sd.schemas \
    %{_sysconfdir}/gconf/schemas/system_smb.schemas \
    %{_sysconfdir}/gconf/schemas/desktop_gnome_url_handlers.schemas \
    %{_sysconfdir}/gconf/schemas/desktop_default_applications.schemas \
      > /dev/null || :
fi

%postun -p /sbin/ldconfig

%files -f %{po_package}.lang
%defattr(-, root, root, -)
%doc AUTHORS COPYING COPYING.LIB NEWS README

%dir %{_sysconfdir}/gnome-vfs-2.0
%dir %{_sysconfdir}/gnome-vfs-2.0/modules
%config %{_sysconfdir}/gnome-vfs-2.0/modules/*.conf
%exclude %{_sysconfdir}/gnome-vfs-2.0/modules/smb-module.conf
%{_bindir}/*
%{_libexecdir}/*
%{_libdir}/*.so.*
%exclude %{_libdir}/gnome-vfs-2.0/modules/libsmb.so
%{_libdir}/gnome-vfs-2.0/modules
%dir %{_libdir}/gnome-vfs-2.0
%{_sysconfdir}/gconf/schemas/*
%{_datadir}/dbus-1/services/gnome-vfs-daemon.service
## conflicts with gnome-vfs 1, ignore for now
## %{_datadir}/man/man5/*

%files devel
%defattr(-, root, root)
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_libdir}/gnome-vfs-2.0/include
%{_includedir}/*
%{_datadir}/gtk-doc/html/gnome-vfs-2.0

%files smb
%defattr(-, root, root)
%{_libdir}/gnome-vfs-2.0/modules/libsmb.so
%config %{_sysconfdir}/gnome-vfs-2.0/modules/smb-module.conf


%changelog

